scala.tools.nsc.backend.jvm

# BCodeAsmCommon

###
Related Doc: package jvm

#### final class BCodeAsmCommon[G <: Global] extends AnyRef

This trait contains code shared between GenBCode and GenASM that depends on types defined in the compiler cake (Global).

Source
  BCodeAsmCommon.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. BCodeAsmCommon
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new BCodeAsmCommon(global: G)

### Type Members

1. #### final case class EnclosingMethodEntry(owner: String, name: String, methodDescriptor: String) extends Product with Serializable

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from BCodeAsmCommon[G] to any2stringadd[BCodeAsmCommon[G]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (BCodeAsmCommon[G], B)

   Implicit information
     This member is added by an implicit conversion from BCodeAsmCommon[G] to ArrowAssoc[BCodeAsmCommon[G]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### lazy val AnnotationRetentionPolicyClassValue: G.Symbol

7. #### lazy val AnnotationRetentionPolicyModule: G.Symbol

8. #### lazy val AnnotationRetentionPolicyRuntimeValue: G.Symbol

9. #### lazy val AnnotationRetentionPolicySourceValue: G.Symbol

10. #### val ExcludedForwarderFlags: Long

11. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

12. #### def classOriginallyNestedInClass(nestedClass: G.Symbol, enclosingClass: G.Symbol): Boolean

13. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

14. #### def considerAsTopLevelImplementationArtifact(classSym: G.Symbol): Boolean

    True for classes generated by the Scala compiler that are considered top-level in terms of the InnerClass / EnclosingMethod classfile attributes.

    True for classes generated by the Scala compiler that are considered top-level in terms of the InnerClass / EnclosingMethod classfile attributes. See comment in BTypes.

15. #### object delambdafyInline

    Cache the value of delambdafy == "inline" for each run.

    Cache the value of delambdafy == "inline" for each run. We need to query this value many times, so caching makes sense.

16. #### def enclosingMethodAttribute(classSym: G.Symbol, classDesc: (G.Symbol) ⇒ String, methodDesc: (G.Symbol) ⇒ String): Option[EnclosingMethodEntry]

    Data for emitting an EnclosingMethod attribute.

    Data for emitting an EnclosingMethod attribute. None if `classSym` is a member class (not an anonymous or local class). See doc in BTypes.

    The class is parametrized by two functions to obtain a bytecode class descriptor for a class symbol, and to obtain a method signature descriptor fro a method symbol. These function depend on the implementation of GenASM / GenBCode, so they need to be passed in.

17. #### def ensuring(cond: (BCodeAsmCommon[G]) ⇒ Boolean, msg: ⇒ Any): BCodeAsmCommon[G]

    Implicit information
      This member is added by an implicit conversion from BCodeAsmCommon[G] to Ensuring[BCodeAsmCommon[G]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: (BCodeAsmCommon[G]) ⇒ Boolean): BCodeAsmCommon[G]

    Implicit information
      This member is added by an implicit conversion from BCodeAsmCommon[G] to Ensuring[BCodeAsmCommon[G]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: Boolean, msg: ⇒ Any): BCodeAsmCommon[G]

    Implicit information
      This member is added by an implicit conversion from BCodeAsmCommon[G] to Ensuring[BCodeAsmCommon[G]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean): BCodeAsmCommon[G]

    Implicit information
      This member is added by an implicit conversion from BCodeAsmCommon[G] to Ensuring[BCodeAsmCommon[G]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

22. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

23. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

24. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from BCodeAsmCommon[G] to StringFormat[BCodeAsmCommon[G]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

25. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

26. #### val global: G

27. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

28. #### def implementedInterfaces(classSym: G.Symbol): List[G.Symbol]

29. #### def isAnonymousOrLocalClass(classSym: G.Symbol): Boolean

    True if `classSym` is an anonymous class or a local class.

    True if `classSym` is an anonymous class or a local class. I.e., false if `classSym` is a member class. This method is used to decide if we should emit an EnclosingMethod attribute. It is also used to decide whether the "owner" field in the InnerClass attribute should be null.

30. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

31. #### def isOriginallyStaticOwner(sym: G.Symbol): Boolean

    This is basically a re-implementation of sym.isStaticOwner, but using the originalOwner chain.

    This is basically a re-implementation of sym.isStaticOwner, but using the originalOwner chain.

    The problem is that we are interested in a source-level property. Various phases changed the symbol's properties in the meantime, mostly lambdalift modified (destructively) the owner. Therefore, `sym.isStatic` is not what we want. For example, in object T { def f { object U } } the owner of U is T, so UModuleClass.isStatic is true. Phase travel does not help here.

32. #### def isRuntimeVisible(annot: G.AnnotationInfo): Boolean

33. #### def memberClassesForInnerClassTable(classSymbol: G.Symbol): List[G.Symbol]

    The member classes of a class symbol.

    The member classes of a class symbol. Note that the result of this method depends on the current phase, for example, after lambdalift, all local classes become member of the enclosing class.

    Impl classes are always considered top-level, see comment in BTypes.

34. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

35. #### def nextEnclosing(sym: G.Symbol): G.Symbol

    The next enclosing definition in the source structure.

    The next enclosing definition in the source structure. Includes anonymous function classes under delambdafy:inline, even though they are only generated during UnCurry.

36. #### def nextEnclosingClass(sym: G.Symbol): G.Symbol

37. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

38. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

39. #### def shouldEmitAnnotation(annot: G.AnnotationInfo): Boolean

    Whether an annotation should be emitted as a Java annotation .initialize: if 'annot' is read from pickle, atp might be un-initialized

40. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

41. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

42. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

43. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

44. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

45. #### def →[B](y: B): (BCodeAsmCommon[G], B)

    Implicit information
      This member is added by an implicit conversion from BCodeAsmCommon[G] to ArrowAssoc[BCodeAsmCommon[G]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from BCodeAsmCommon[G] to any2stringadd[BCodeAsmCommon[G]]

### Inherited by implicit conversion StringFormat from BCodeAsmCommon[G] to StringFormat[BCodeAsmCommon[G]]

### Inherited by implicit conversion Ensuring from BCodeAsmCommon[G] to Ensuring[BCodeAsmCommon[G]]

### Inherited by implicit conversion ArrowAssoc from BCodeAsmCommon[G] to ArrowAssoc[BCodeAsmCommon[G]]

### Ungrouped